/************************************************************************

 The contents of this file are subject to the Mozilla Public License
 Version 1.1 (the "License"); you may not use this file except in	
 compliance with the License. You may obtain a copy of the License at
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS"
 basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 License for the specific language governing rights and limitations
 under the License.

 The Original Code is Isearch.

 The Initial Developer of the Original Code is Clearinghouse for
 Networked Information Discovery and Retrieval.

 Portions created by Netscape Communications are Copyright (C) 2001. 
 All Rights Reserved.

 Portions created by the Clearinghouse for Networked Information
 Discovery and Retrieval are Copyright (C) 1994. All Rights Reserved.

************************************************************************/

/* A simple parser that will find the start of every word. */

#include "simple.h"
#include "defs.h"

SIMPLE::SIMPLE(PIDBOBJ DbParent) : DOCTYPE(DbParent) 
{
}


double 
SIMPLE::ScoreHit(IRESULT result, double termweight) {
  
    double Weight = 1.0;
    int Depth;

    if (result.MiscFields & COOL_FLAG_MASK) {
        Weight = 3.0;
    }

    // adjust score based on the depth of the category
    Depth = result.CatDepth;
    if (Depth <= 0)
        Depth = 1;
    Weight *= (1.0 / ( (DOUBLE) Depth ));

    if (result.HitCount < 1)
        result.HitCount = 1;

    // adjust score for the number of hits in this record, range [1.0, 2.0)
    Weight *= ((double)2.0 - ((double)1.0 / ((double)result.HitCount)));

    return(termweight * Weight);
}  

SIMPLE::~SIMPLE() 
{
}
