#!/bin/sh
#************************************************************************
#
# The contents of this file are subject to the Mozilla Public License
# Version 1.1 (the "License"); you may not use this file except in	
# compliance with the License. You may obtain a copy of the License at
# http://www.mozilla.org/MPL/
#
# Software distributed under the License is distributed on an "AS IS"
# basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
# License for the specific language governing rights and limitations
# under the License.
#
# The Original Code is Isearch.
#
# The Initial Developer of the Original Code is Clearinghouse for
# Networked Information Discovery and Retrieval.
#
# Portions created by Netscape Communications are Copyright (C) 2001. 
# All Rights Reserved.
#
# Portions created by the Clearinghouse for Networked Information
# Discovery and Retrieval are Copyright (C) 1994. All Rights Reserved.
#
#************************************************************************
#
# usage: build_odp_index 
#

if [ -r "content.rdf" ] ; then
    print "ERROR: can't find file list: content.rdf"
    print "Usage: build_index"
    exit 1
fi

echo "Generating BFB and filelists for indexing"
rdf2bfb

echo "Generating Category Search Index"
Iindex -d category -t SIMPLE -f category.filelist

# This trick forces both the category and site database
# to use the same hash table for category (directory) names.
# This allows fast comparisons of category names, and saves
# disk space.
ln -s category.pn site.pn

echo "Generating Site Search Index"
Iindex -d site -t SITEDOC -f site.filelist

