/************************************************************************

 The contents of this file are subject to the Mozilla Public License
 Version 1.1 (the "License"); you may not use this file except in	
 compliance with the License. You may obtain a copy of the License at
 http://www.mozilla.org/MPL/

 Software distributed under the License is distributed on an "AS IS"
 basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 License for the specific language governing rights and limitations
 under the License.

 The Original Code is Isearch.

 The Initial Developer of the Original Code is Clearinghouse for
 Networked Information Discovery and Retrieval.

 Portions created by Netscape Communications are Copyright (C) 2001. 
 All Rights Reserved.

 Portions created by the Clearinghouse for Networked Information
 Discovery and Retrieval are Copyright (C) 1994. All Rights Reserved.

************************************************************************/

#include "defs.h"
#include "string.h"
#include "common.h"
#include "record.h"
#include "mdthashtable.h"

extern MDTHASHTABLE ht;


RECORD::RECORD() {
	pathName=0;
	fileName=0;
	RecordStart=0;
	RecordEnd=0;
	DocumentType=0;;
}

RECORD::RECORD(STRING& NewPathName, STRING& NewFileName) {
	pathName = ht.AddPathName(NewPathName);
	// RemovePath(&NewFileName);
	fileName = ht.AddFileName(NewFileName);
}

RECORD& RECORD::operator=(const RECORD& OtherRecord) {
	pathName = OtherRecord.pathName;
	fileName = OtherRecord.fileName;
	RecordStart = OtherRecord.RecordStart;
	RecordEnd = OtherRecord.RecordEnd;
	DocumentType = OtherRecord.DocumentType;
	return *this;
}

void RECORD::SetPathName(const STRING& NewPathName) {
	pathName = ht.AddPathName(NewPathName);
}

void RECORD::GetPathName(PSTRING StringBuffer) const {
	*StringBuffer = ht.GetPathName(pathName);
}

void RECORD::SetFileName(const STRING& NewFileName) {
	// RemovePath(&NewFileName);
	fileName = ht.AddFileName(NewFileName);
}

void RECORD::GetFileName(PSTRING StringBuffer) const {
	*StringBuffer = ht.GetFileName(fileName);
}

void RECORD::GetFullFileName(PSTRING StringBuffer) const {
        char *tmp;
	tmp = ht.GetPathName(pathName);
	*StringBuffer = tmp;
	// XXX - free(tmp);

	tmp = ht.GetFileName(fileName);
	StringBuffer->Cat(tmp);
	// XXX - free(tmp);	
}

void RECORD::SetRecordStart(const GPTYPE NewRecordStart) {
	RecordStart = NewRecordStart;
}

GPTYPE RECORD::GetRecordStart() const {
	return RecordStart;
}

void RECORD::SetRecordEnd(const GPTYPE NewRecordEnd) {
	RecordEnd = NewRecordEnd;
}

GPTYPE RECORD::GetRecordEnd() const {
	return RecordEnd;
}

void RECORD::SetDocumentType(unsigned char NewDocumentType) {
	DocumentType = NewDocumentType;
}

unsigned char RECORD::GetDocumentType() const{
        return DocumentType;
}

void RECORD::Write(PFILE fp) const {
	fprintf(fp, "%d\n", pathName);
	fprintf(fp, "%d\n", fileName);
	fprintf(fp, "%d\n", RecordStart);
	fprintf(fp, "%d\n", RecordEnd);
	fprintf(fp, "%d\n", DocumentType);
}

void RECORD::Read(PFILE fp) {
	STRING s;
	s.FGet(fp, 16);
	pathName = s.GetInt();
	s.FGet(fp, 16);
	fileName = s.GetInt();
	s.FGet(fp, 16);
	RecordStart = s.GetInt();
	s.FGet(fp, 16);
	RecordEnd = s.GetInt();
	s.FGet(fp, 16);
	DocumentType = s.GetInt();
}

RECORD::~RECORD() {
}
